"use strict";
// Copyright (c) Jupyter Development Team.
// Distributed under the terms of the Modified BSD License.
Object.defineProperty(exports, "__esModule", { value: true });
const coreutils_1 = require("@phosphor/coreutils");
const base_1 = require("@jupyter-widgets/base");
// TODO: import from @jupyter-widgets/jupyterlab-manager once Output is
// exported by the main module.
const output_1 = require("@jupyter-widgets/jupyterlab-manager/lib/output");
const widget_1 = require("./widget");
const version_1 = require("./version");
require("../css/floatview.css");
const EXTENSION_ID = '@jupyter-widgets/jupyterlab-floatview';
const floatviewPlugin = {
    id: EXTENSION_ID,
    requires: [base_1.IJupyterWidgetRegistry],
    activate: activateWidgetExtension,
    autoStart: true
};
exports.default = floatviewPlugin;
/**
 * Activate the widget extension.
 */
function activateWidgetExtension(app, registry) {
    let FloatviewView = class extends output_1.OutputView {
        render() {
            if (!this.model.rendered) {
                super.render();
                let w = this._outputView;
                w.addClass('jupyterlab-floatview');
                w.addClass('jp-LinkedOutputView');
                w.title.label = this.model.get('title');
                w.title.closable = true;
                /*w.title.closable = true;
                app.shell['_rightHandler'].sideBar.tabCloseRequested.connect((sender : any, tab : any) => {
                    tab.title.owner.dispose();
                });*/
                app.shell['_dockPanel'];
                w.id = coreutils_1.UUID.uuid4();
                if (Object.keys(this.model.views).length > 1) {
                    w.node.style.display = 'none';
                    let key = Object.keys(this.model.views)[0];
                    this.model.views[key].then((v) => {
                        v._outputView.activate();
                    });
                }
                else {
                    app.shell.addToMainArea(w, { mode: this.model.get('mode') });
                    /*app.shell.expandRight();*/
                }
            }
        }
    };
    registry.registerWidget({
        name: '@jupyter-widgets/jupyterlab-floatview',
        version: version_1.EXTENSION_SPEC_VERSION,
        exports: {
            FloatviewModel: widget_1.FloatviewModel,
            FloatviewView: FloatviewView
        }
    });
}
